unit DE48u1;

//ready for publishing with tut.

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, INIFiles;

const ver='21Sept13';
      //Code started 21 Sep 13, NC
      kMaxArr=6;//The full flexibility allowed for by using this
         //has not been programmed into all of the rest of the code yet.

type

  { TDE48f1 }

  TDE48f1 = class(TForm)
    buDoIt: TButton;
    buQuit: TButton;
    laCredits: TLabel;
    meBuildTextFile: TMemo;
    Timer1: TTimer;
    procedure buDoItClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    sImageFolder:array[0..kMaxArr]of string;
    dtDateStamp:array[0..kMaxArr]of TDatetime;
    sPathToAssmFldr:string;
    bMaxArrElInUse:byte;
    procedure DoIt;
    procedure CopyFiles(bHowMany:byte);
    procedure FillMemo;
    procedure FillVariousVariables;
    procedure SaveMemo;
    function sFileNSource(bWhich:byte; var dtTmpDateStamp:TDateTime):string;
  public
    { public declarations }
  end;

var
  DE48f1: TDE48f1;

implementation

{$R *.lfm}

{ TDE48f1 }

procedure TDE48f1.buDoItClick(Sender: TObject);
begin
 DoIt;
end;

procedure TDE48f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure TDE48f1.DoIt;
begin
 FillVariousVariables;
 CopyFiles(4);
 FillMemo;
 SaveMemo;
end;

procedure TDE48f1.FillMemo;
   function sLineOfHTML(sTmp1,sTmp2:string):string;
    (*This is done a little crudely, in respect of the "L" and "R"
      Yes...  images always in sub-folder "Images" inside folder
      where Tmp.htm is going to be saved. Not a problem, and in
      some respects (other than the actual name), there's not
      much option about this, either. The "copy" routine will just
      have to Deal With It.*)
    begin
      if sTmp2='L' then
      sLineOfHTML:='<img align="left" '+
                'width="45%" src="Images\TmpImg'+sTmp1+'.jpg" '+
                'alt="No such file">';
      if sTmp2='R' then
      sLineOfHTML:='<img align="right" '+
                'width="45%" src="Images\TmpImg'+sTmp1+'.jpg" '+
                'alt="No such file">';
      if (sTmp2<>'L') and (sTmp2<>'R') then
      sLineOfHTML:='<p>There''s an error in the app''s code. Err 13921a</p>';
    end;

begin
 meBuildTextFile.clear;//Empty the memo first
 meBuildTextFile.lines.add('<html>');
 meBuildTextFile.lines.add('<head>');
 meBuildTextFile.lines.add('</head>');
 meBuildTextFile.lines.add('<body>');
 meBuildTextFile.lines.add('<p>The next two images had datestamps of: '+datetostr(dtDateStamp[0])+
                 ' and '+datetostr(dtDateStamp[1])+'</p>');
 meBuildTextFile.lines.add(sLineOfHTML('01','L'));
 meBuildTextFile.lines.add(sLineOfHTML('02','R'));
 meBuildTextFile.lines.add('<br clear=left><br clear=right>');
 meBuildTextFile.lines.add('<p>The next two images had datestamps of: '+datetostr(dtDateStamp[2])+
                 ' and '+datetostr(dtDateStamp[3])+'</p>');
 meBuildTextFile.lines.add(sLineOfHTML('03','L'));
 meBuildTextFile.lines.add(sLineOfHTML('04','R'));
 meBuildTextFile.lines.add('<br clear=left><br clear=right>');
 meBuildTextFile.lines.add('</body>');
 meBuildTextFile.lines.add('</html>');
end;

procedure TDE48f1.FillVariousVariables;
begin
  sPathToAssmFldr:='';
  if sPathToAssmFldr<>'' then if
    sPathToAssmFldr[length(sPathToAssmFldr)]<>'\' then
      sPathToAssmFldr:=sPathToAssmFldr+'\';
  bMaxArrElInUse:=3;

end;

procedure TDE48f1.SaveMemo;
begin
 meBuildTextFile.lines.savetofile(sPathToAssmFldr+'DE48pics.htm');
end;

procedure TDE48f1.CopyFiles(bHowMany:byte);
var bCount:byte;
    dtTmpDateStamp:TDateTime;
function sDestFN(bWhich:byte):string;
//There's no need to build in flexibility in the
//  naming of these files, they are "internal",
//  in a dedicated folder, pointed to by sAssmFldr
  begin
    case bWhich of
    0:sDestFN:='Images\TmpImg01.jpg';//This can also be done "cleverly"
    1:sDestFN:='Images\TmpImg02.jpg';// ... but why bother, here?
    2:sDestFN:='Images\TmpImg03.jpg';
    3:sDestFN:='Images\TmpImg04.jpg';
    //(Should also have "else"clause to catch inadvertent overflows
    //  which could easily arise during careless tweaking of program;
    end;//case
   end;//sDestFN
begin
 for bCount:=0 to bHowMany do begin
     copyfile(sImageFolder[bCount]+sFileNSource(bCount,dtTmpDateStamp),
              sPathToAssmFldr+sDestFN(bCount));
     dtDateStamp[bCount]:=dtTmpDateStamp;
    end;//for
end;

function TDE48f1.sFileNSource(bWhich:byte; var dtTmpDateStamp:TDateTime):string;
//This is to a degree artificial... the commercial extension of this
//   tutorial will fill sFileNSource and the dtDateStamp values more cleverly
begin
  case bWhich of
    0:begin
      sFileNSource:='Img152.jpg';
      dtTmpDateStamp:=14;
      end;
    1:begin
      sFileNSource:='Img155.jpg';
      dtTmpDateStamp:=15;
      end;
    2:begin
      sFileNSource:='Img199.jpg';
      dtTmpDateStamp:=16;
      end;
    3:begin
      sFileNSource:='Img200.jpg';
      dtTmpDateStamp:=17;
      end;
      //(Should also have "else"clause to catch inadvertent overflows
      //  which could easily arise during careless tweaking of program;
    end;//case
  end;

procedure TDE48f1.FormActivate(Sender: TObject);
var dfIniFile:TInifile;
begin
  dfIniFile:=TIniFile.Create('DE48ini.txt');
  with dfIniFile do begin
   sImageFolder[0]:=ReadString('SourcePaths','1','C:\DE48DataRoot\pseudoroot\IVA152\');
   sImageFolder[1]:=ReadString('SourcePaths','2','C:\DE48DataRoot\pseudoroot\IVA155\');
   sImageFolder[2]:=ReadString('SourcePaths','3','C:\DE48DataRoot\pseudoroot\IVA199\');
   sImageFolder[3]:=ReadString('SourcePaths','4','C:\DE48DataRoot\pseudoroot\IVA200\');

   DE48f1.top   :=ReadInteger('PosnAndSize','Top'   ,10);
   DE48f1.left  :=ReadInteger('PosnAndSize','Left'  ,20);
   DE48f1.height:=ReadInteger('PosnAndSize','Height',300);
   DE48f1.width :=ReadInteger('PosnAndSize','Width' ,500);

   end;//with...
  dfIniFile.Free;
end;

procedure TDE48f1.FormDestroy(Sender: TObject);
var dfIniFile:TInifile;
begin
 dfIniFile:=TIniFile.Create('DE48ini.txt');
 with dfIniFile do begin
  WriteString('SourcePaths','1',sImageFolder[0]);
  WriteString('SourcePaths','2',sImageFolder[1]);
  WriteString('SourcePaths','3',sImageFolder[2]);
  WriteString('SourcePaths','4',sImageFolder[3]);

  WriteInteger('PosnAndSize','Top'   ,DE48f1.top);
  WriteInteger('PosnAndSize','Left'  ,DE48f1.left);
  WriteInteger('PosnAndSize','Height',DE48f1.height);
  WriteInteger('PosnAndSize','Width' ,DE48f1.width);

  end;//with...                         2
 dfIniFile.Free;

end;

procedure TDE48f1.Timer1Timer(Sender: TObject);
begin
  buDoIt.enabled:=false;
  DoIt;
  buDoIt.enabled:=true;
end;


end.

